## win32-loader 0.10.4

=== Makefile ===
export SHELL := bash

BUILD_DIR ?= build
HELPERS_DIR := helpers
MKDIR_P := mkdir -p
RMDIR := rmdir

HELPER_DIRS := $(patsubst %/.,%,$(wildcard $(CURDIR)/$(HELPERS_DIR)/*/.))
HELPERS := $(notdir $(HELPER_DIRS))

define HELPER_template =
$(2)_helper: $(1)
	$(MKDIR_P) $(BUILD_DIR)/$(HELPERS_DIR)/$(2)
	$(MAKE) -C $(BUILD_DIR)/$(HELPERS_DIR)/$(2) \
		-f "$$</Makefile" "VPATH=$$<"

$(2)_clean: $(1)
	if [ -d $(BUILD_DIR)/$(HELPERS_DIR)/$(2) ]; then \
		$(MAKE) -C $(BUILD_DIR)/$(HELPERS_DIR)/$(2) \
			-f "$$</Makefile" clean; \
		$(RMDIR) $(BUILD_DIR)/$(HELPERS_DIR)/$(2); \
	fi
endef

# Targets that will always be run (as they depend on stuff from installed packages)
.PHONY: clean distclean test $(BUILD_DIR)/core.img $(BUILD_DIR)/g2ldr $(BUILD_DIR)/g2ldr.mbr $(BUILD_DIR)/loadlin.pif $(BUILD_DIR)/loadlin.exe $(BUILD_DIR)/pxe.lkrn $(HELPERS:=_helper) $(HELPERS:=_clean)

PACKAGE	:= win32-loader
VERSION	:= $(shell head -n 1 debian/changelog | sed -e "s/^$(PACKAGE) (\(.*\)).*/\1/g")

ifndef SOURCE_DATE_EPOCH
SOURCE_DATE_EPOCH	:= $(shell git log -1 --pretty=%ct 2>/dev/null || LC_ALL=C date +'%s')
export SOURCE_DATE_EPOCH
endif

FOUR_DIGITS_DATE	:= $(shell date -u +'%Y.%m.%d.%H%M' --date="@$(SOURCE_DATE_EPOCH)")

NSIS_CC		:= i686-w64-mingw32-gcc -Os -Xlinker --no-insert-timestamp
NSIS_STRIP	:= i686-w64-mingw32-strip
NSIS_CFLAGS	:= -Wl,--file-alignment,512 -Werror -D_WIN32_WINNT=0x0500

ICONSIZES       := 16,24,32,48,256
# Density calculation:
# The default resolution of 72 dots per inch is used to get the
# equivalent of one point per pixel.
# 108 is the width and height of the SVG.
# 256 is the width and height of the largest icon.
# So density will be (256 * 72) / 108 = 170
DENSITY         := 170

# Standard makensis call
MAKENSIS	:= makensis -V3 "-XUnicode True"

# Add to it some version'ing and date
MAKENSIS	+= -DVERSION=$(VERSION) -D4DIGITS_DATE=$(FOUR_DIGITS_DATE)

ifndef OUTFILE_NAME
OUTFILE_NAME	:= $(BUILD_DIR)/win32-loader.exe
endif
MAKENSIS	+= -D_OUTFILE_NAME=$(OUTFILE_NAME) -DBUILD_DIR=$(BUILD_DIR)

# Distributor/Company name (defaults to "The Debian Project")
ifdef COMPANY_NAME
MAKENSIS	+= -D_COMPANY_NAME=$(COMPANY_NAME)
endif

# Distribution name (ASCII only, please)
ifdef TARGET_DISTRO
MAKENSIS	+= -DTARGET_DISTRO=$(TARGET_DISTRO)
endif

# Standalone version : Not linked to a website with preseed.cfg
ifdef STANDALONE
MAKENSIS	+= -DNOCD=yes
OPTIONS_TXT	+= +net
endif

# Network version : Linked to a website with preseed.cfg
ifdef NETWORK_BASE_URL
# Embed the sha256sum of the $(NETWORK_BASE_URL)/preseed.cfg file for enhanced security.
MAKENSIS	+= -DNETWORK_BASE_URL=$(NETWORK_BASE_URL) -DNOCD=yes -DNETWORK_BASE_URL_CHECKSUM=$(NETWORK_BASE_URL_CHECKSUM)
OPTIONS_TXT	+= +url
endif

# PXE version (which is standalone too)
ifdef PXE
MAKENSIS	+= -DPXE=yes -DNOCD=yes
OPTIONS_TXT	+= +pxe
endif

# Disabling the kFreeBSD download
ifndef NOT_ALLKERNELS
MAKENSIS	+= -DALLKERNELS=yes
OPTIONS_TXT	+= +kernels
endif

# Allowing the branch selection
ifdef DAILIES
MAKENSIS	+= -DDAILIES=yes
OPTIONS_TXT	+= +dailies
endif

ifdef OPTIONS_TXT
MAKENSIS	+= -DOPTIONS_TXT="$(OPTIONS_TXT)"
endif

# hard disk
GRUB_MODULES	+= biosdisk
# partmap
GRUB_MODULES	+= part_msdos part_gpt
# fs
GRUB_MODULES	+= fat ntfs ntfscomp
# used in our grub.cfg
GRUB_MODULES	+= search linux bsd multiboot vbe boot
# might be useful for debugging
GRUB_MODULES	+= minicmd cat cpuid chain halt help ls reboot
# useful for loading files from ISO images
GRUB_MODULES	+= loopback iso9660
ifndef NOT_ALLKERNELS
# gzio is needed for kFreeBSD
GRUB_MODULES    += gzio
endif
ifdef PXE
# Booting the pxe.lkrn requires linux16
GRUB_MODULES	+= linux16
endif

all: $(OUTFILE_NAME) $(BUILD_DIR)/g2ldr $(BUILD_DIR)/g2ldr.mbr

$(BUILD_DIR):
	$(MKDIR_P) $(BUILD_DIR)

$(foreach helper_dir,$(HELPER_DIRS),$(eval $(call HELPER_template,$(helper_dir),$(notdir $(helper_dir)))))

core.img:
	grub-mkimage --output=$@ --prefix=/win32-loader --format=i386-pc $(GRUB_MODULES)

$(BUILD_DIR)/g2ldr: /usr/lib/grub/i386-pc/g2hdr.bin core.img | $(BUILD_DIR)
	cat $^ > $@

$(BUILD_DIR)/g2ldr.mbr: /usr/lib/grub/i386-pc/g2ldr.mbr | $(BUILD_DIR)
	cp $^ $@

$(BUILD_DIR)/loadlin.pif: genpif | $(BUILD_DIR)
	bash $^ > $@

$(BUILD_DIR)/loadlin.exe: /usr/lib/loadlin/loadlin.exe.gz | $(BUILD_DIR)
	gunzip -c $^ > $@

$(BUILD_DIR)/pxe.lkrn: /usr/lib/ipxe/ipxe.lkrn | $(BUILD_DIR)
	cp $^ $@

ifdef PXE
PXE_TARGETS = $(BUILD_DIR)/pxe.lkrn
else
PXE_TARGETS =
endif

templates/gtk.bmp: templates/gtk_orig.png
	convert $^ -resize 107x80 BMP3:$@

# Build the icon out of the SVG source
$(BUILD_DIR)/win32-loader.ico: icon/swirl.svg | $(BUILD_DIR)
	convert -background none -density $(DENSITY) $^ -depth 8 -colors 256 -dither FloydSteinberg -define png:compression-filter=1 -define png:compression-level=9 -define png:compression-strategy=1 -define icon:auto-resize=$(ICONSIZES) $@

$(OUTFILE_NAME): main.nsi maps.ini \
		templates/gtk.bmp templates/text.bmp \
		$(PXE_TARGETS) $(BUILD_DIR)/win32-loader.ico \
		$(BUILD_DIR)/loadlin.pif $(BUILD_DIR)/loadlin.exe \
		$(BUILD_DIR)/g2ldr $(BUILD_DIR)/g2ldr.mbr \
		| $(HELPERS:=_helper)
	find $(BUILD_DIR) -type f -exec touch --date="@$(SOURCE_DATE_EPOCH)" '{}' ';'
	$(MKDIR_P) $(BUILD_DIR)/l10n
	$(MAKE) -C $(BUILD_DIR)/l10n -f $(CURDIR)/l10n/Makefile VPATH=$(CURDIR)/l10n
	$(MAKENSIS) main.nsi
	du -h $(OUTFILE_NAME)

test:  $(HELPERS:=_helper)
ifneq ($(shell wine --version 2>&1),)
	$(CURDIR)/tests/run.sh $(realpath $(BUILD_DIR)) win32 \
		$(realpath $(BUILD_DIR))
ifeq ($(notdir $(shell winepath -u c:/windows/system32 2>/dev/null)),syswow64)
	$(CURDIR)/tests/run.sh $(realpath $(BUILD_DIR)) win64 \
		$(realpath $(BUILD_DIR))
endif
endif

iso: $(BUILD_DIR)/stable.iso $(BUILD_DIR)/daily.iso
$(BUILD_DIR)/stable.iso: \
  $(BUILD_DIR)/netboot/download-stable-stamp \
  $(BUILD_DIR)/netboot/stable/win32-loader.exe \
  $(BUILD_DIR)/netboot/stable/g2ldr \
  $(BUILD_DIR)/netboot/stable/g2ldr.mbr \
  $(BUILD_DIR)/netboot/stable/autorun.inf \
  $(BUILD_DIR)/netboot/stable/win32-loader.ini \
  $(NULL) | $(BUILD_DIR)
	genisoimage -r -J -o $@ $(BUILD_DIR)/netboot/stable

$(BUILD_DIR)/daily.iso: \
  $(BUILD_DIR)/netboot/download-daily-stamp \
  $(BUILD_DIR)/netboot/daily/win32-loader.exe \
  $(BUILD_DIR)/netboot/daily/g2ldr $(BUILD_DIR)/netboot/daily/g2ldr.mbr \
  $(BUILD_DIR)/netboot/daily/autorun.inf \
  $(BUILD_DIR)/netboot/daily/win32-loader.ini \
  $(NULL) | $(BUILD_DIR)
	genisoimage -r -J -o $@ $(BUILD_DIR)/netboot/daily

BASE_URL=http://deb.debian.org/debian/dists/stable/main
$(BUILD_DIR)/netboot/download-stable-stamp:
	$(MKDIR_P) $(BUILD_DIR)/netboot/stable/install.{386,amd}/gtk
	wget $(BASE_URL)/installer-i386/current/images/netboot/debian-installer/i386/linux \
		-O $(BUILD_DIR)/netboot/stable/install.386/vmlinuz
	wget $(BASE_URL)/installer-i386/current/images/netboot/debian-installer/i386/initrd.gz \
		-O $(BUILD_DIR)/netboot/stable/install.386/initrd.gz
	wget $(BASE_URL)/installer-i386/current/images/netboot/gtk/debian-installer/i386/initrd.gz \
		-O $(BUILD_DIR)/netboot/stable/install.386/gtk/initrd.gz
	wget $(BASE_URL)/installer-amd64/current/images/netboot/debian-installer/amd64/linux \
		-O $(BUILD_DIR)/netboot/stable/install.amd/vmlinuz
	wget $(BASE_URL)/installer-amd64/current/images/netboot/debian-installer/amd64/initrd.gz \
		-O $(BUILD_DIR)/netboot/stable/install.amd/initrd.gz
	wget $(BASE_URL)/installer-amd64/current/images/netboot/gtk/debian-installer/amd64/initrd.gz \
		-O $(BUILD_DIR)/netboot/stable/install.amd/gtk/initrd.gz
	touch $@

$(BUILD_DIR)/netboot/download-daily-stamp:
	$(MKDIR_P) $(BUILD_DIR)/netboot/daily/install.{386,amd}/gtk
	wget https://d-i.debian.org/daily-images/i386/daily/netboot/debian-installer/i386/linux \
		-O $(BUILD_DIR)/netboot/daily/install.386/vmlinuz
	wget https://d-i.debian.org/daily-images/i386/daily/netboot/debian-installer/i386/initrd.gz \
		-O $(BUILD_DIR)/netboot/daily/install.386/initrd.gz
	wget https://d-i.debian.org/daily-images/i386/daily/netboot/gtk/debian-installer/i386/initrd.gz \
		-O $(BUILD_DIR)/netboot/daily/install.386/gtk/initrd.gz
	wget https://d-i.debian.org/daily-images/amd64/daily/netboot/debian-installer/amd64/linux \
		-O $(BUILD_DIR)/netboot/daily/install.amd/vmlinuz
	wget https://d-i.debian.org/daily-images/amd64/daily/netboot/debian-installer/amd64/initrd.gz \
		-O $(BUILD_DIR)/netboot/daily/install.amd/initrd.gz
	wget https://d-i.debian.org/daily-images/amd64/daily/netboot/gtk/debian-installer/amd64/initrd.gz \
		-O $(BUILD_DIR)/netboot/daily/install.amd/gtk/initrd.gz
	touch $@

$(BUILD_DIR)/netboot/stable/autorun.inf $(BUILD_DIR)/netboot/daily/autorun.inf: autorun.inf
	$(MKDIR_P) $(BUILD_DIR)/netboot/{stable,daily}
	todos < $< > $@

$(BUILD_DIR)/netboot/stable/win32-loader.ini $(BUILD_DIR)/netboot/daily/win32-loader.ini: win32-loader.ini
	$(MKDIR_P) $(BUILD_DIR)/netboot/{stable,daily}
	todos < $< > $@

$(BUILD_DIR)/netboot/stable/win32-loader.exe $(BUILD_DIR)/netboot/daily/win32-loader.exe: $(OUTFILE_NAME)
	$(MKDIR_P) $(BUILD_DIR)/netboot/{stable,daily}
	cp $^ $@

$(BUILD_DIR)/netboot/stable/% $(BUILD_DIR)/netboot/daily/%: $(BUILD_DIR)/%
	$(MKDIR_P) $(BUILD_DIR)/netboot/{stable,daily}
	cp $< $@

clean:
	if [ -d $(BUILD_DIR)/$(HELPERS_DIR) ]; then \
		$(MAKE) $(HELPERS:=_clean); \
		$(RMDIR) $(BUILD_DIR)/$(HELPERS_DIR); \
	fi
	if [ -d $(BUILD_DIR)/l10n ]; then \
		$(MAKE) -C $(BUILD_DIR)/l10n \
			-f $(CURDIR)/l10n/Makefile clean; \
		$(RMDIR) $(BUILD_DIR)/l10n; \
	fi
	rm -f 	$(OUTFILE_NAME) \
		$(BUILD_DIR)/*.iso $(BUILD_DIR)/*~ $(BUILD_DIR)/*/*~ \
		$(BUILD_DIR)/core.img \
		$(BUILD_DIR)/g2ldr $(BUILD_DIR)/g2ldr.mbr \
		$(BUILD_DIR)/loadlin.pif $(BUILD_DIR)/loadlin.exe \
		$(BUILD_DIR)/pxe.lkrn $(BUILD_DIR)/icon/*.png \
		$(BUILD_DIR)/win32-loader.ico
	if [ -d $(BUILD_DIR)/icon ]; then $(RMDIR) $(BUILD_DIR)/icon; fi

distclean: clean
	rm -rf $(BUILD_DIR)/netboot
	if [ -d $(BUILD_DIR) ]; then $(RMDIR) $(BUILD_DIR); fi

=== l10n/Makefile ===
# Add only languages really supported by NSIS there
# For others, a PO file may be added and kept until NSIS is translated
# Languages not yet supported by NSIS: ast bn dz kk ml ta te ug vi

VPATH ?= .
MKDIR_P := mkdir -p
TEMPLATES := $(CURDIR)/templates
PO := po

DISABLED_LINGUAS=
LINGUAS= ar be bg bs ca cs da de el en eo es eu fa fi fr ga gl he hr hu is it ja ko lt nb nl pl pt pt_BR ro ru sk sl sq sr sr@latin sv th tr uk zh_CN zh_TW

all: $(TEMPLATES)/all.nsh $(TEMPLATES)/dialog.nsh $(VPATH)/$(PO)/messages.pot

$(TEMPLATES):
	$(MKDIR_P) $@

$(TEMPLATES)/dialog.nsh: win32-loader.sh $(TEMPLATES)/all.nsh | $(TEMPLATES)
	for i in $(LINGUAS) ; do \
		echo "Push \$${`LANGUAGE=$$i $< LANG_ENGLISH`}" ; \
		echo "Push \"`LANGUAGE=$$i $< English`\"" ; \
	done > $@

$(TEMPLATES)/all.nsh: $(foreach lang, $(LINGUAS), $(TEMPLATES)/$(lang).nsh) | $(TEMPLATES)
	for i in $^ ; do echo "; BEGIN $$i" ; cat $$i ; echo "; END $$i" ; done > $@

$(TEMPLATES)/en.nsh: win32-loader.sh | $(TEMPLATES)
	LANGUAGE=C $(realpath $<) > $@

locale/%/LC_MESSAGES/win32-loader.mo: $(PO)/%.po $(VPATH)/$(PO)/messages.pot | $(TEMPLATES)
	$(MKDIR_P) locale/$*/LC_MESSAGES
	msgmerge -U $< $(dir $<)messages.pot
	msgfmt -c --statistics -o $@ $<

$(TEMPLATES)/%.nsh: win32-loader.sh locale/%/LC_MESSAGES/win32-loader.mo | $(TEMPLATES)
	LANGUAGE=$* $(realpath $<) > $@

$(PO)/messages.pot: win32-loader.sh
	xgettext --add-comments=translate --from-code=utf-8 --language=Shell --msgid-bugs-address=win32-loader@packages.debian.org --output=$@ $^

clean:
	rm -rf $(TEMPLATES) locale
	rm -f $(foreach lang, $(LINGUAS), $(PO)/$(lang).po~)

=== helpers/cpuid/Makefile ===
# Licensed under the zlib/libpng license (same as NSIS)

AS = i686-w64-mingw32-as
LD = i686-w64-mingw32-ld
ASFLAGS = -march=i486
LDFLAGS = -m i386pe --add-stdcall-alias --dll --dynamicbase \
	--enable-auto-image-base --entry _DllEntryPoint@12 \
	--nxcompat --strip-all --subsystem windows

TARGET = cpuid.dll
cpuid_OBJS = cpuid_dll.o

.PHONY: clean

all:: $(TARGET)

clean::
	rm -f $(TARGET) $(cpuid_OBJS)

cpuid.dll: $(cpuid_OBJS)
	$(LD) $(LDFLAGS) $^ -o $@

=== helpers/instdlg/Makefile ===
# Licensed under the zlib/libpng license (same as NSIS)

AS = i686-w64-mingw32-as
LD = i686-w64-mingw32-ld
IMAGE_BASE = 0x400000
ASFLAGS = --defsym IMAGE_BASE=$(IMAGE_BASE) -march=i486
LDFLAGS = --image-base $(IMAGE_BASE) --strip-all --subsystem windows

TARGET = instdlg.exe
instdlg_OBJS = instdlg.o

.PHONY: clean

all:: $(TARGET)

clean::
	rm -f $(TARGET) $(instdlg_OBJS)

$(TARGET): $(instdlg_OBJS)
	$(LD) $(LDFLAGS) $^ -o $@

=== helpers/miniz/Makefile ===
# Licensed under the zlib/libpng license (same as NSIS)

CC = i686-w64-mingw32-gcc
CPPFLAGS = -DMINIZ_NO_ARCHIVE_APIS=1 -DMINIZ_NO_MALLOC=1 \
	-DMINIZ_NO_ZLIB_APIS=1 -DNDEBUG
CFLAGS = -Os -ffunction-sections -pedantic
LDFLAGS = -s -shared -Wl,--add-stdcall-alias,--gc-sections
LIBS = -nostdlib -static-libgcc -lgcc -lkernel32

TARGET = miniz.dll
OBJS = main.o miniz.o miniz_tdef.o

.PHONY:	clean

all::	$(TARGET)

clean::
	rm -f $(TARGET) $(OBJS)

$(TARGET):	$(OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

=== helpers/sha256/Makefile ===
# Licensed under the zlib/libpng license (same as NSIS)

CC = i686-w64-mingw32-gcc
CFLAGS = -Os -Wall -pedantic -s
LDFLAGS = -s -shared -Wl,--add-stdcall-alias
LIBS = -nostdlib -lkernel32

TARGET = sha256.dll
sha256_OBJS = sha256.o sha256-x86.o

.PHONY: clean

all:: $(TARGET)

clean::
	rm -f $(TARGET) $(sha256_OBJS)

$(TARGET): $(sha256_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

=== debian/changelog ===
win32-loader (0.10.4) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Run win64 tests only on 64-bit wine
  * Makefile: Add build directory as prerequisite for icon generation
  * s_install.nsi: Fix indentation
  * Use signed grub efi file of testing instead of buster
    The signed grub efi file of buster lacks the leading / in the prefix.
  * l10n: Generate translations only via shell script,
    update po and pot files
  * Write entries to preseed.cfg one by one
    By default NSIS limits strings to 1024 characters. Writing each entry
    destined for preseed.cfg on its own prevents a possible data loss.
  * Use "create error" message in case adding preseed.cfg to
    installer's initrd.gz fails
  * Restore variables before returning from Get_SHA256_ref
  * Download signed grub efi file of testing (bullseye) if the one
    of stable (buster) is faulty determined by its sha256 fingerprint

  [ Updated translations ]
  * Russian (ru.po) by Yuri Kozlov. Closes: #974891

  [ Didier Raboud ]
  * Bump S-V to 4.5.1 without changes needed

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 11 Jan 2021 08:24:07 +0100

win32-loader (0.10.2) unstable; urgency=medium

  [ Didier Raboud ]
  * Correct typo in 0.10.1 changelog entry
  * Coerce same-author d/changelog entries

  [ Thomas Gaugler ]
  * Update patch of signed netboot grub EFI file as required by a newly
    released and signed netboot grub EFI file addressing the GRUB2
    "BootHole" vulnerability
  * Use respective prefix path of netboot grub
    - The default netboot grub prefix is /debian-installer/amd64/grub
      but /grub for the patched version.
  * helpers/instdlg: Consolidate image base definition in one place
  * tests/sha256: Release crypto context instead of file handle
  * tests:
    - Launch shell scripts via -e option to exit in case of failure
    - Change camelCase functions into lowercase named ones
    - Map uninstaller init function un..onInit to un.onInit
    - Move run and check functions of (Un)Installer to common place
  * tests/cpio: Run tests in uninstaller context as well
  * SYSINFO_ComputerName replace StrLoc with custom implementation
  * tests/sysinfo: Run tests in uninstaller context as well
  * Support output format filters for cpio
  * miniz compression helper
  * Provide interface and tests for miniz helper
  * Use MINIZ_CPIO_GZ_* functions to append preseed.cfg to initrd.gz
  * Be explicit about path receiving translated installer messages (.nsh)
  * Run tests based on availability of wine and host architecture
  * Add cpio required during test phase as dependency
  * Remove no longer needed gzip-win32 dependency
  * Increase to debhelper compatibility level 13
  * Dropping Win ME/98/95 support in favor of Unicode support
  * Enable Farsi translation
  * d/copyright: Add license information for helpers and include directories

 -- Didier Raboud <odyx@debian.org>  Sat, 03 Oct 2020 15:38:07 +0200

win32-loader (0.10.1) unstable; urgency=medium

  * Team upload

  [ Thomas Gaugler ]
  * Skip blhc job in Salsa CI pipeline
  * Generate the installer icon from the SVG source in one go, so drop
    icoutils B-D
  * d/control: Set Rules-Requires-Root to no
  * d/control: Update to Standards-Version 4.5.0
  * Test win32-loader in its installed state
  * Limit updating of timestamps to build directory

  [ Updated translations ]
  * Czech (cs.po) by Miroslav Kure
  * German (de.po) by Holger Wansing
  * Korean (ko.po) by Changwoo Ryu
  * Portuguese (Brazil) (pt_BR.po) by Adriano Rafael Gomes

 -- Didier Raboud <odyx@debian.org>  Thu, 16 Jul 2020 18:18:40 +0200

win32-loader (0.10.0) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Introduce UEFI boot manager and Secure Boot support (Closes: #918863)
    - Patch netboot debian-installer grub efi file (temporary workaround)
  * Use Modern User Interface
  * Replace 'vga=' option with gfxpayload in grub.cfg
  * Major code refactor and cleanup:
    - Enable downloading via https for Windows 7 or newer
    - Allow GPG validity check in a folder with spaces
    - Add progress text and tidy up localization files
    - Replace use of external cpio.exe
    - Remove obsolete plugins
    - Use SOURCE_DATE_EPOCH and DEB_VERSION

  [ Didier Raboud ]
  * Trim trailing whitespace.
  * Disable Farsi translation as its NSIS translation doesn't convert
    correctly to its designated codepage, see #939151
  * Bump debhelper from old 11 to 12, and S-V to 4.4.0 without changes needed
  * Add standard Salsa Gitlab-CI configuration

 -- Didier Raboud <odyx@debian.org>  Mon, 02 Sep 2019 08:50:12 +0200

=== debian/control ===
Source: win32-loader
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Thomas Gaugler <thomas@dadie.net>,
           Didier Raboud <odyx@debian.org>
Section: utils
Priority: optional
Build-Depends: nsis (>= 3),
               mingw-w64,
               librsvg2-bin,
               gawk,
               gettext (>= 0.20),
               grub-pc-bin,
               imagemagick,
               ipxe,
               loadlin,
               locales-all,
               gpgv-win32,
               debian-archive-keyring,
               cpio,
               wine [i386],
               debhelper-compat (= 13)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/installer-team/win32-loader
Vcs-Git: https://salsa.debian.org/installer-team/win32-loader.git

Package: win32-loader
Architecture: all
Depends: ${misc:Depends}
Suggests: wine
Built-Using: ${w32-loader:built-using}
Description: Debian-Installer loader for win32
 This package provides a win32 program that can be used as a loader for
 Debian Installer, acting as a more user-friendly boot mechanism than
 traditional BIOS-based boot.
 .
 This package contains the cdrom/usb-disk add-on that starts a media-based
 install.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

BUILD_DIR := build

# Install the win32-loader-standalone.exe as debian/tools/win32-loader/$(SUITE)/win32-loader.exe on the mirrors
BYHAND ?= yes

W32_BYHAND_NAME := win32-loader_$(DEB_VERSION)_all

B_D_PACKAGES := grub-pc-bin gzip-win32 gpgv-win32 debian-archive-keyring loadlin ipxe nsis

PACKAGES_LIST := $(shell set -e; \
	for p in ${B_D_PACKAGES}; \
	do \
		dpkg-query --showformat='$${source:Package;-25} $${source:Version;-25} http://deb.debian.org/debian/pool/main/$${source:Package;1}/$${source:Package}\\n' --show $$p; \
	done)

BUILT_USING_LIST := $(shell set -e; \
	for p in ${B_D_PACKAGES}; \
	do \
		dpkg-query --showformat='$${source:Package} (= $${source:Version}), ' --show $$p; \
	done)

NSIS_VERSION  := $(shell dpkg-query -f='$${Version}' -W nsis )

%:
	dh $@

override_dh_auto_build:
ifeq ($(BYHAND),yes)
	# Build the standalone+pxe version
	# Don't allow non-Linux kernels, as their download is currently broken (see #819092)
	dh_auto_build -- STANDALONE=yes \
		PXE=yes \
		NOT_ALLKERNELS=yes \
		OUTFILE_NAME="$(BUILD_DIR)/$(W32_BYHAND_NAME).exe" \
		BUILD_DIR="$(BUILD_DIR)"
	
	# Prepare the README file
	gawk '{sub(/@PACKAGES_LIST@/,"$(PACKAGES_LIST)")}1 \
	      {sub(/@NSIS_VERSION@/,"$(NSIS_VERSION)")}1 \
	      {sub(/@W32_VERSION@/,"$(DEB_VERSION)")}1' \
		debian/win32-loader_doc.txt \
		> "$(BUILD_DIR)/$(W32_BYHAND_NAME).txt"
	cat debian/copyright >> "$(BUILD_DIR)/$(W32_BYHAND_NAME).txt"
endif
	# Build the cdrom version
	dh_auto_build -- OUTFILE_NAME="$(BUILD_DIR)/win32-loader.exe" \
		BUILD_DIR="$(BUILD_DIR)"

override_dh_install:
	dh_install --sourcedir="$(BUILD_DIR)"

override_dh_auto_clean:
	rm -f "$(BUILD_DIR)/$(W32_BYHAND_NAME).exe" \
		"$(BUILD_DIR)/$(W32_BYHAND_NAME).txt"
	dh_auto_clean -- BUILD_DIR="$(BUILD_DIR)"

override_dh_builddeb:
	dh_builddeb
ifeq ($(BYHAND),yes)
	cp "$(BUILD_DIR)/$(W32_BYHAND_NAME).exe" ../
	dpkg-distaddfile "$(W32_BYHAND_NAME).exe" byhand -

	cp "$(BUILD_DIR)/$(W32_BYHAND_NAME).txt" ../
	dpkg-distaddfile "$(W32_BYHAND_NAME).txt" byhand -
endif

override_dh_gencontrol:
	dh_gencontrol -- -Vw32-loader:built-using="$(BUILT_USING_LIST)"

=== debian/tests/control ===
Test-Command: 7z t -tNsis "/usr/share/win32/win32-loader.exe"
Depends: @, p7zip-full

## win32-loader 0.10.6

=== debian/changelog ===
win32-loader (0.10.6) unstable; urgency=medium

  * Team upload

  [ Andika Triwidada ]
  * Update Indonesian translation. Closes: #1007707

 -- Holger Wansing <hwansing@mailbox.org>  Mon, 21 Mar 2022 23:58:02 +0100

win32-loader (0.10.5) unstable; urgency=medium

  [ Valentin Vidic ]
  * Update Croatian translation

  [ Didier Raboud ]
  * Run wrap-and-sort -baskt
  * Remove myself from Uploaders

 -- Didier Raboud <odyx@debian.org>  Wed, 01 Sep 2021 18:28:42 +0200

=== debian/control ===
Source: win32-loader
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders:
 Thomas Gaugler <thomas@dadie.net>,
Section: utils
Priority: optional
Build-Depends:
 cpio,
 debhelper-compat (= 13),
 debian-archive-keyring,
 gawk,
 gettext (>= 0.20),
 gpgv-win32,
 grub-pc-bin,
 imagemagick,
 ipxe,
 librsvg2-bin,
 loadlin,
 locales-all,
 mingw-w64,
 nsis (>= 3),
 wine [i386],
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/installer-team/win32-loader
Vcs-Git: https://salsa.debian.org/installer-team/win32-loader.git

Package: win32-loader
Architecture: all
Depends:
 ${misc:Depends},
Suggests:
 wine,
Built-Using:
 ${w32-loader:built-using},
Description: Debian-Installer loader for win32
 This package provides a win32 program that can be used as a loader for
 Debian Installer, acting as a more user-friendly boot mechanism than
 traditional BIOS-based boot.
 .
 This package contains the cdrom/usb-disk add-on that starts a media-based
 install.

=== debian/tests/control ===
Test-Command: 7z t -tNsis "/usr/share/win32/win32-loader.exe"
Depends:
 p7zip-full,
 @,
